#!/bin/sh
# Original date: 2024-02-28
# Version: 1.1
# Date: 2024-05-05
set -eu
readonly program=./bytes
readonly directory="$(dirname $0)"
cmd="diff -"
if [ ! -f "$directory/input0.txt" ]
then
head -c 1000 /dev/urandom > "$directory/input0.txt"
cmd=tee
fi
$program "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 0 failed
$program -s "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output01.txt" || echo test 1 failed
$program -n 0 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output02.txt" || echo test 2 failed
$program -s -n 0 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output03.txt" || echo test 3 failed
$program -n 2 -N 5 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output04.txt" || echo test 4 failed
$program -s -n 2 -N 5 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output05.txt" || echo test 5 failed
$program -n 2 -N 5 -p 0.003 -P 0.004 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output06.txt" || echo test 6 failed
$program -s -n 2 -N 5 -p 0.003 -P 0.004 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output07.txt" || echo test 7 failed
$program -n 2 -N 5 -p 0.0025 -P 0.0045 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output06.txt" || echo test 8 failed
$program -s -n 2 -N 5 -p 0.0025 -P 0.0045 "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output07.txt" || echo test 9 failed
cat "$directory/input0.txt" | $program | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 10 failed
cat "$directory/input0.txt" | $program - | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 11 failed
$program -f "%d '%A%B%E' %n\n" -e "%t\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 12 failed
$program -f "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 13 failed
$program -F "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 14 failed
$program -f "%d '%A%B%E' %n\n" -f "" -F "%d '%A%B%E' %n\n" -e "%t\n" -E "%t\n" -e "" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 15 failed
$program -E "%d '%A%B%E' %n\n" -F "%t\n" -F "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output00.txt" || echo test 16 failed
if [ ! -f "$directory/input1.txt" ]
then
head -c 1000 /dev/urandom > "$directory/input1.txt"
cmd=tee
fi
$program "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 17 failed
$program -s "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output09.txt" || echo test 18 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program -l - | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 19 failed
{ echo "$directory/input0.txt"; echo "#$directory/input0.txt"; echo "$directory/input1.txt"; } | $program -l - | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 20 failed
printf "%s\0" "$directory/input0.txt" "$directory/input1.txt" | $program -L - | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 21 failed
printf "%s\0" "$directory/input0.txt" "$directory/input1.txt" | $program --null-list - | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 22 failed
printf "%s\0" "$directory/input0.txt" "$directory/input1.txt" | $program --n - | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 23 failed
printf "%s\0" "$directory/input0.txt" "$directory/input1.txt" | $program --n=- | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 24 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program -sl- | sed 's:'$directory/'::' | $cmd "$directory/output09.txt" || echo test 25 failed
$program -f "%f: %d '%A%B%E' %n\n" -e "%f: %t\n" -F "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output08.txt" || echo test 26 failed
$program -s -f "%f: %d '%A%B%E' %n\n" -e "%f: %t\n" -F "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output09.txt" || echo test 27 failed
$program -f "%f: %d '%A%B%E' %n\n" -e "%f: %t\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output10.txt" || echo test 28 failed
$program -F "%d '%A%B%E' %n\n" -E "%t\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output11.txt" || echo test 29 failed
cat "$directory/input0.txt" "$directory/input1.txt" | $program -f "%d '%A%B%E' %n\n" -e "%t\n" - | sed 's:'$directory/'::' | $cmd "$directory/output11.txt" || echo test 30 failed
cat "$directory/input0.txt" "$directory/input1.txt" | $program -F "%d '%A%B%E' %n\n" -E "%t\n" - | sed 's:'$directory/'::' | $cmd "$directory/output11.txt" || echo test 31 failed
$program -b "%f (%t):\n" -f "%X %x %b %O %o %B%S%e %n/%t %p %P%%\n" -B "combined (%t):\n" -F "%X %x %b %O %o %B%S%e %n/%t %p %P%%\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output12.txt" || echo test 32 failed
$program -s -p 0.007  -B "\"" -F "%B%Q%c" -E "\"\n" "$directory/input0.txt" "$directory/input1.txt" | sed 's:'$directory/'::' | $cmd "$directory/output13.txt" || echo test 33 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program -s -n 2 -N 15 -p 0.007  -P 0.009 -b "%f:\n" -f "%B%Q%E %n %p\n" -e "\n" -B "combined:\n" -F "%B%Q%E %n %p\n" -E "\n" -l - | sed 's:'$directory/'::' | $cmd "$directory/output14.txt" || echo test 34 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program --sort --minimum-count 2 --maximum-count 15 --minimum-proportion 0.007  --maximum-proportion 0.009 --begin-file-format "%f:\n" --item-file-format "%B%Q%E %n %p\n" --end-file-format "\n" --begin-combined-format "combined:\n" --item-combined-format "%B%Q%E %n %p\n" --end-combined-format "\n" --list - | sed 's:'$directory/'::' | $cmd "$directory/output14.txt" || echo test 35 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program --sort --minimum-count=2 --maximum-count=15 --minimum-proportion=0.007  --maximum-proportion=0.009 --begin-file-format="%f:\n" --item-file-format="%B%Q%E %n %p\n" --end-file-format="\n" --begin-combined-format="combined:\n" --item-combined-format="%B%Q%E %n %p\n" --end-combined-format="\n" --list=- | sed 's:'$directory/'::' | $cmd "$directory/output14.txt" || echo test 36 failed
{ echo "$directory/input0.txt"; echo "$directory/input1.txt"; } | $program --s --minimum-c=2 --maximum-c=15 --minimum-p=0.007  --maximum-p=0.009 --begin-f="%f:\n" --item-f="%B%Q%E %n %p\n" --end-f="\n" --begin-c="combined:\n" --item-c="%B%Q%E %n %p\n" --end-c="\n" --l=- | sed 's:'$directory/'::' | $cmd "$directory/output14.txt" || echo test 37 failed
$program -E "\t\011\11\164\1454\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 38 failed
$program -E "\t\o011\o11\o164\o1454\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 39 failed
$program -E "\cI\ci\c\c\t\c4\c%4\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 40 failed
$program -E "\d009\d09\d9\d116\d1014\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 41 failed
$program -E "\x09\x9\x9\x74\x654\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 42 failed
$program -E "\u0009\u009\u09\u74\u00654\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 43 failed
$program -E "\u9\U00000009\U0000009\U74\U000000654\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 44 failed
$program -E "\U000009\U00009\U0009\U074\U000000654\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 45 failed
$program -E "\U009\U09\U9\U0074\U000000654\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output15.txt" || echo test 46 failed
$program -b "\d120\d194\d179\d32\d226\d137\d164\d32\d207\d128\d32\d43\d32\d207\d141\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output16.txt" || echo test 47 failed
$program -b "\x78\xC2\xB3\x20\xE2\x89\xA4\x20\xCF\x80\x20\x2B\x20\xCF\x8D\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output16.txt" || echo test 48 failed
$program -b "\u78\uB3\u20\u2264\u20\u3C0\u20\u2B\u20\u3CD\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output16.txt" || echo test 49 failed
$program -b "\U78\Ub3\U20\U2264\U20\U3c0\U20\U2b\U20\U3cd\n" "$directory/input0.txt" | sed 's:'$directory/'::' | $cmd "$directory/output16.txt" || echo test 50 failed
$program -sab 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output17.txt" || echo test 51 failed
$program -sàb 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output18.txt" || echo test 52 failed
$program -sb 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output19.txt" || echo test 53 failed
$program -sn 0.1 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output20.txt" || echo test 54 failed
$program -sp -1.1 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output21.txt" || echo test 55 failed
$program -sp 1.1 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output22.txt" || echo test 56 failed
$program --m 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output23.txt" || echo test 57 failed
$program --missing 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output24.txt" || echo test 58 failed
$program -n 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output25.txt" || echo test 59 failed
$program --minimum-count 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output26.txt" || echo test 60 failed
$program -n "" 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output27.txt" || echo test 61 failed
$program --minimum-count "" 2>&1 | sed 's:'$directory/'::' | $cmd "$directory/output28.txt" || echo test 62 failed
